#include "SDL.h"
#include "SDL_opengl.h"


#include "container.h"
#include "entity.h"
#include "random.h"

namespace PRJID {


Container::Container() {
}
Container::~Container() {
	clear();
}

void Container::clear() {
}
void Container::remove(unsigned int i) {
}


void Container::add(Entity *e,bool special) {
	e->set_container(this);
	entities.insert(entities.end(),e);
}

void Container::tick(unsigned int ticks) {
	if (ticks==0) return;
	std::list <Entity *>::iterator it;

	for (it=entities.begin();it!=entities.end();it++) {
		(*it)->tick(ticks);
	}

}

void Container::act(unsigned int ticks) {
	std::list <Entity *>::iterator it;

	for (it=entities.begin();it!=entities.end();it++) {
		(*it)->act(ticks);
	}
}

void Container::draw() {
	std::list <Entity *>::iterator it;

	for (it=entities.begin();it!=entities.end();it++) {
		(*it)->draw();
	}
}

void Container::set_game(Game *g) {
	game=g;
}


Entity * Container::create(e_entitytype t) {
	Entity *n;
	n=new Entity();
	add(n);
	return n;
}


} //namespace
