#ifndef __el__entity_h
#define __el__entity_h

#include "release.h"
#include <iostream>
#include <vector>

#include "coordinate.h"
#include "entitytype.h"
#include "tweak/tweak.h"

#include "position.h"


namespace PRJID {

class Container;
class Game;

class Entity {
	Container *container_;
	bool snap();
	void init();

	float speed;

	bool m_forward,m_backward,m_left,m_right;
	e_entitytype type;
	Position position;
	unsigned int myticks;
public:
	Entity();

	void set_container(Container *c) { container_=c; }

	C3f get_pos();
	void set_pos(C3f);
	C3f get_rot();

	void scene_rot() { position.rotate(); }
	void scene_trans() { position.translate();}

	void draw();
	bool isactive();
	
	void act(unsigned int ticks);
	void tick(unsigned int ticks);
	bool trymove(C3f d);

	void move_direction(C3f r,float mod=1.0f);
	void move_forward(float mod=1.0f);
	void move_backward(float mod=1.0f);
	void move_left(float mod=1.0f);
	void move_right(float mod=1.0f);


	void mark_move_forward();
	void mark_move_backward();
	void mark_move_left();
	void mark_move_right();

	void turn_up();
	void turn_down();
	void turn_left();
	void turn_right();
	void turn(int x,int y);

};


} //namespace

#endif
